<?php

/****************************************************************************************
* LiveZilla functions.external.inc.php
* 
* Copyright 2001-2008 SPAUN Power GmbH
* All rights reserved.
* LiveZilla is a registered trademark.
* 
* Improper changes in this file may cause critical errors. It is strongly 
* recommended to desist from editing this file.
* 
***************************************************************************************/

if(!defined("IN_LIVEZILLA"))
	die();

function listen($_user)
{
	global $CONFIG,$GROUPS,$INTERNAL,$USER;
	$USER = $_user;
	if(!IS_FILTERED)
	{
		if(isnull($USER->Browsers[0]->Chat))
		{
			getData(true,false,false,false);
			$USER->Browsers[0]->SetCookieGroup();
			$response = getIntern();
			login();
			if(count($USER->Browsers) > 0 && isset($INTERNAL[$USER->Browsers[0]->DesiredChatPartner]) && $USER->Browsers[0]->CreateChat($INTERNAL[$USER->Browsers[0]->DesiredChatPartner]))
				$USER->AddFunctionCall($response,false);
			if($USER->Browsers[0]->Waiting)
				displayWaitingMessage();
		}
		else
		{
			activeListen();
		}
	}
	else
		displayFiltered();
	return $USER;
}

function activeListen($runs = 1,$picUpdate=false)
{
	global $CONFIG,$GROUPS,$INTERNAL,$USER,$ISFORWARD;
	$start = time();
	$USER->Browsers[0]->Typing = isset($_POST[POST_EXTERN_TYPING]);
	while(time() < $start + getLongPollRuntime() || $runs == 1)
	{
		isForward();
		processForward();
		if($runs > 1)
		{
			getData(false,false,false,true);
			$USER->Browsers[0]->LoadChat($CONFIG["timeout_clients"],null);
			if($USER->Browsers[0]->Chat == NULL)
				break;
		}
		if($USER->Browsers[0]->Chat->MemberCount == 1)
		{
			displayQuit();return $USER;
		}
		else if($USER->Browsers[0]->Chat->Closed)
		{
			displayQuit();return $USER;
		}
		else if($USER->Browsers[0]->Chat->Declined)
		{
			displayDeclined();return $USER;
		}
		else if($USER->Browsers[0]->Chat->Activated == CHAT_STATUS_WAITING)
			beginnConversation();
		else if($USER->Browsers[0]->Chat->Activated != CHAT_STATUS_ACTIVE)
			displayWaitingMessage();
			
		if($USER->Browsers[0]->Chat->Activated >= CHAT_STATUS_WAITING)
		{
			$picUpdate = refreshPicture();
			processTyping();
		}
		
		if($runs == 1 && isset($_POST[POST_EXTERN_USER_FILE_UPLOAD_NAME]) && !isset($_POST[POST_EXTERN_USER_FILE_UPLOAD_ERROR]) && !$ISFORWARD)
			$USER = $USER->Browsers[0]->RequestFileUpload($USER,$_POST[POST_EXTERN_USER_FILE_UPLOAD_NAME]);
		else if($runs == 1 && isset($_POST[POST_EXTERN_USER_FILE_UPLOAD_NAME]) && isset($_POST[POST_EXTERN_USER_FILE_UPLOAD_ERROR]))
			$USER->Browsers[0]->AbortFileUpload($USER,namebase($_POST[POST_EXTERN_USER_FILE_UPLOAD_NAME]),$_POST[POST_EXTERN_USER_FILE_UPLOAD_ERROR]);
	
		if($runs++ == 1 && isset($_POST[POST_GLOBAL_SHOUT]))
			processPosts();
			
		if($USER->Browsers[0]->Chat->Activated == CHAT_STATUS_ACTIVE)
			getPosts();

		if(isset($_POST[POST_GLOBAL_SHOUT]) || isset($_POST[POST_GLOBAL_LAST_CONNECTION_FAILED]))
		{
			break;
		}
		else if(md5($USER->Response) != $_POST[POST_GLOBAL_XMLCLIP_HASH_ALL] || $picUpdate)
		{
			$USER->AddFunctionCall("lz_chat_listen_hash('". md5($USER->Response) . "');",false);
			break;
		}
		else
		{
			$USER->Response = "";
			$wait = max($CONFIG["poll_frequency_clients"]-1,1);
			if(time()+$wait <= $start+getLongPollRuntime())
				sleep($wait);
			else
				break;
		}
	}
}

function isForward()
{
	global $USER,$CONFIG,$ISFORWARD,$ISFORWARDPROCESSED;
	$USER->Browsers[0]->GetForwards();
	$ISFORWARD = (!isnull($USER->Browsers[0]->Forward) && !$USER->Browsers[0]->Forward->Processed);
	$ISFORWARDPROCESSED = (!isnull($USER->Browsers[0]->Forward) && $USER->Browsers[0]->Forward->Processed);
}

function processForward()
{
	global $USER,$CONFIG,$ISFORWARD;
	if($ISFORWARD)
	{
		$USER->AddFunctionCall("lz_chat_file_stop();",false);
		$USER->AddFunctionCall("lz_chat_add_system_text(0,null);",false);
		$USER->AddFunctionCall("lz_chat_set_intern('','','',false,false);",false);
		$USER->AddFunctionCall("lz_chat_set_intern_image(false,false,false,false,'','');",false);
		$USER->Browsers[0]->Chat->ExternalDestroy();
		$USER->Browsers[0]->Chat->InternalDestroy();
		$USER->Browsers[0]->DesiredChatGroup = $USER->Browsers[0]->Forward->TargetGroupId;
		$USER->Browsers[0]->DesiredChatPartner = $USER->Browsers[0]->Forward->TargetSessId;
		$USER->Browsers[0]->Forward->Processed = true;
		$USER->Browsers[0]->Forward->Save();
		$USER->Browsers[0]->WaitingMessageDisplayed = time();
		return true;
	}
	else
	{
		if(!isnull($USER->Browsers[0]->Forward) && !isnull($USER->Browsers[0]->Chat) && $USER->Browsers[0]->Chat->Activated == CHAT_STATUS_ACTIVE)
			if($USER->Browsers[0]->Forward->SenderSessId != $USER->Browsers[0]->DesiredChatPartner)
				$USER->Browsers[0]->Forward->Destroy();
	}
	return false;
}

function getPosts()
{
	global $USER;
	foreach($USER->Browsers[0]->GetPosts() as $posts)
		foreach($posts as $post)
			$USER->AddFunctionCall($post->GetCommand(),false);
	return $USER;
}

function processPosts()
{
	global $USER;
	if(isset($_POST["p_p0"]))
	{
		$PostMan = new PostMan($USER->Browsers[0],null,null);
		$counter = 0;
		while(isset($_POST["p_p" . $counter]))
		{
			$post = new Post($_POST["p_i" . $counter],$USER->Browsers[0],$USER->Browsers[0]->Chat->InternalUser->SystemId,AJAXDecode($_POST["p_p" . $counter]),null,null,time());
			if(strlen($_POST["p_p" . $counter]) > 0)
				$PostMan->AddPost($post);
			$counter++;
		}
		$PostMan->Save();
	}
	$USER->AddFunctionCall("lz_chat_release_posts();",false);
}

function login()
{
	global $INTERNAL,$USER;
	if($_POST[POST_EXTERN_USER_NAME] == null && getCookieValue("login_name") != null)
		$USER->Browsers[0]->Fullname = getCookieValue("login_name");
	else
		$USER->Browsers[0]->Fullname = AJAXDecode($_POST[POST_EXTERN_USER_NAME]);
	
	if($_POST[POST_EXTERN_USER_EMAIL] == null && getCookieValue("login_email") != null)
		$USER->Browsers[0]->Email = getCookieValue("login_email");
	else
		$USER->Browsers[0]->Email = AJAXDecode($_POST[POST_EXTERN_USER_EMAIL]);
	if($_POST[POST_EXTERN_USER_COMPANY] == null && getCookieValue("login_company") != null)
		$USER->Browsers[0]->Company = getCookieValue("login_company");
	else
		$USER->Browsers[0]->Company = (trim($_POST[POST_EXTERN_USER_COMPANY]) != null) ? AJAXDecode($_POST[POST_EXTERN_USER_COMPANY]) : "";
	
	if(isset($_POST[POST_EXTERN_USER_NAME]) && strlen($_POST[POST_EXTERN_USER_NAME]) != null)
		setCookieValue("login_name",($USER->Browsers[0]->Fullname));
	if(isset($_POST[POST_EXTERN_USER_EMAIL]) && strlen($_POST[POST_EXTERN_USER_EMAIL]) != null)
		setCookieValue("login_email",($USER->Browsers[0]->Email));
	if(isset($_POST[POST_EXTERN_USER_COMPANY]) && strlen($_POST[POST_EXTERN_USER_COMPANY]) != null)
		setCookieValue("login_company",($USER->Browsers[0]->Company));

	$USER->AddFunctionCall("lz_chat_set_status(0);",false);
	if(count($USER->Browsers) > 0 && isset($INTERNAL[$USER->Browsers[0]->DesiredChatPartner]) && $INTERNAL[$USER->Browsers[0]->DesiredChatPartner]->UserId != null)
		setCookieValue("internal_user",$INTERNAL[$USER->Browsers[0]->DesiredChatPartner]->UserId);
}

function refreshPicture()
{
	global $CONFIG,$USER;
	$update = (@filemtime($USER->Browsers[0]->Chat->InternalUser->PictureFile) >  time()-$CONFIG["poll_frequency_clients"]*2);
	if(isset($USER->Browsers[0]->Chat->InternalUser->UserId) && (file_exists($USER->Browsers[0]->Chat->InternalUser->WebcamFile) || file_exists($USER->Browsers[0]->Chat->InternalUser->PictureFile)))
		$USER->AddFunctionCall("lz_chat_set_intern_image(true," . parseBool($update) . "," . parseBool(file_exists($USER->Browsers[0]->Chat->InternalUser->WebcamFile)) . ",false,'".$USER->Browsers[0]->Chat->InternalUser->WebcamFile."','".$USER->Browsers[0]->Chat->InternalUser->PictureFile."');",false);
	else
		$USER->AddFunctionCall("lz_chat_set_intern_image(false,false,false,false,'','');",false);
	$USER->AddFunctionCall("lz_chat_set_config(".$CONFIG["timeout_clients"].",".$CONFIG["poll_frequency_clients"].");",false);
	return (file_exists($USER->Browsers[0]->Chat->InternalUser->WebcamFile) || $update);
}

function processTyping()
{
	global $CONFIG,$USER,$GROUPS;
	$USER->AddFunctionCall("lz_chat_set_intern(\"".base64_encode($USER->Browsers[0]->Chat->InternalUser->UserId)."\",\"".base64_encode(addslashes($USER->Browsers[0]->Chat->InternalUser->Fullname))."\",\"".base64_encode(addslashes($GROUPS[$USER->Browsers[0]->DesiredChatGroup]["gr_desc"]))."\",".parseBool($USER->Browsers[0]->DesiredChatPartnerTyping).",".parseBool(file_exists(PATH_VISITCARDS.$USER->Browsers[0]->Chat->InternalUser->UserId.".vcf")).");",false);
}

function beginnConversation()
{
	global $USER;
	$USER->Browsers[0]->Chat->ExternalActivate();
	$USER->AddFunctionCall("lz_chat_add_system_text(1,'".base64_encode($USER->Browsers[0]->Chat->InternalUser->Fullname)."');",false);
	$USER->AddFunctionCall("lz_chat_set_status(1);",false);
	$USER->AddFunctionCall("lz_chat_shout();",false);
}

function displayFiltered()
{
	global $FILTERS,$USER;
	$USER->Browsers[0]->DestroyChatFiles();
	$USER->AddFunctionCall("lz_chat_set_intern('','','',false,false);",false);
	$USER->AddFunctionCall("lz_chat_set_status(2);",false);
	$USER->AddFunctionCall("lz_chat_add_system_text(2,'".base64_encode("&nbsp;<b>".addslashes($FILTERS->Filters[ACTIVE_FILTER_ID]->Reason)."</b>")."');",false);
	$USER->AddFunctionCall("lz_chat_stop_system();",false);
	$USER->AddFunctionCall("lz_chat_set_intern_image(false,false,false,true,'','');",false);
}

function displayQuit()
{
	global $GROUPS,$USER;
	$USER->Browsers[0]->DestroyChatFiles();
	$USER->AddFunctionCall("lz_chat_set_intern('','','',false,false);",false);
	$USER->AddFunctionCall("lz_chat_set_status(2);",false);
	$USER->AddFunctionCall("lz_chat_add_system_text(3,null);",false);
	$USER->AddFunctionCall("lz_chat_stop_system();",false);
}

function displayDeclined()
{
	global $GROUPS,$USER;
	$USER->Browsers[0]->DestroyChatFiles();
	$USER->AddFunctionCall("lz_chat_set_intern('','','',false,false);",false);
	$USER->AddFunctionCall("lz_chat_set_status(2);",false);
	$USER->AddFunctionCall("lz_chat_add_system_text(4,null);",false);
	$USER->AddFunctionCall("lz_chat_stop_system();",false);
}

function displayWaitingMessage()
{
	global $GROUPS,$USER;
	if(isnull($USER->Browsers[0]->WaitingMessageDisplayed))
		$USER->Browsers[0]->WaitingMessageDisplayed = time();
	else if($USER->Browsers[0]->WaitingMessageDisplayed == -1)
		return;
		
	if($USER->Browsers[0]->WaitingMessageDisplayed < time()-60)
	{
		$USER->Browsers[0]->WaitingMessageDisplayed = -1;
		$USER->AddFunctionCall("lz_chat_add_system_text(5,null);",false);
	}
}

function buildLoginErrorField($error="",$addition = "")
{
	global $FILTERS;
	if(!getAvailability())
		$error = "<!--lang_client_error_deactivated-->";
		
	if(IS_FILTERED)
	{
		$error = "<!--lang_client_error_unavailable-->";
		if(isset($FILTERS->Message) && strlen($FILTERS->Message) > 0)
			$addition = "<br><br>" . $FILTERS->Message;
	}
	return $error . $addition;
}

function reloadGroups($_user)
{
	global $CONFIG,$INTERNAL,$GROUPS;
	getData(true,false,false,true);
	$groupbuilder = new GroupBuilder($INTERNAL,$GROUPS,$CONFIG);
	$groupbuilder->Generate();

	if(isset($_POST[POST_EXTERN_REQUESTED_INTERNID]) && !isnull($_POST[POST_EXTERN_REQUESTED_INTERNID]))
		$_user->Browsers[0]->DesiredChatPartner = getInternSessIdByUserId(AJAXDecode($_POST[POST_EXTERN_REQUESTED_INTERNID]));

	$_user->AddFunctionCall("top.lz_chat_set_groups(\"" . $groupbuilder->Result . "\" ,". $groupbuilder->ErrorHTML .");",true);
	$_user->AddFunctionCall("lz_chat_release(".parseBool(($groupbuilder->GroupAvailable || (isset($_POST[GET_EXTERN_RESET]) && strlen($groupbuilder->ErrorHTML) <= 2))).",".$groupbuilder->ErrorHTML.");",false);
	return $_user;
}

function getIntern($response = "")
{
	global $CONFIG,$INTERNAL,$GROUPS,$USER,$ISFORWARDPROCESSED;
	if(!isnull($USER->Browsers[0]->DesiredChatPartner))
		$desired = $USER->Browsers[0]->DesiredChatPartner;
	else if(getCookieValue("internal_user") != null)
		$desired = getInternSessIdByUserId(getCookieValue("internal_user"));
		
	foreach($GROUPS as $id => $group)
		$utilization[$id] = 0;
	foreach($INTERNAL as $sessId => $internal)
	{
		if($internal->FileError != null)
			return;
		if($internal->LastActive > (time()-$CONFIG["timeout_clients"]))
		{
			$group_chats[$sessId] = $internal->GetExternalChatAmount();
			$group_names[$sessId] = $internal->Fullname;
			$group_available[$sessId] = GROUP_STATUS_UNAVAILABLE;

			if(in_array($USER->Browsers[0]->DesiredChatGroup,$internal->Groups))
			{
				if($internal->Status == "0"){$group_available[$sessId] = GROUP_STATUS_AVAILABLE;}
				elseif($internal->Status== "1"){$group_available[$sessId] = GROUP_STATUS_BUSY;}
			}
			
			for($count=0;$count<count($internal->Groups);$count++)
			{
				if($USER->Browsers[0]->DesiredChatGroup == $internal->Groups[$count] || $desired == $sessId)
				{
					if(!is_array($utilization[$internal->Groups[$count]]))
						$utilization[$internal->Groups[$count]] = Array();
					if($group_available[$sessId] == GROUP_STATUS_AVAILABLE)
						$utilization[$internal->Groups[$count]][$sessId] = $group_chats[$sessId];
					break;
				}
			}
		}
	}
	
	if(isset($utilization[$USER->Browsers[0]->DesiredChatGroup]) && is_array($utilization[$USER->Browsers[0]->DesiredChatGroup]))
	{
		arsort($utilization[$USER->Browsers[0]->DesiredChatGroup]);
		reset($utilization[$USER->Browsers[0]->DesiredChatGroup]);
		$util = end($utilization[$USER->Browsers[0]->DesiredChatGroup]);
	}
	if(isset($group_available) && is_array($group_available) && in_array(GROUP_STATUS_AVAILABLE,$group_available))
		$fromDepartment = true;
	elseif(isset($group_available) && is_array($group_available) && in_array(GROUP_STATUS_BUSY,$group_available))
		$fromDepartmentBusy = true;

	isForward();
	if(isset($group_chats) && is_array($group_chats) && isset($fromDepartment) && $fromDepartment)
		foreach($group_chats as $sessId => $amount)
		{
			if(($group_available[$sessId] == GROUP_STATUS_AVAILABLE  && $amount <= $util) || ($ISFORWARDPROCESSED && isset($desired) && $sessId == $desired))
				$available_internals[] = $sessId;
		}
	
	if(isset($fromDepartment) && $fromDepartment && sizeof($available_internals) > 0)
	{	
		$USER->Browsers[0]->Waiting = false;
		if(is_array($available_internals))
		{
			if(isset($desired) && !isnull($desired) && in_array($desired,$available_internals))
			{
				$matching_internal = $desired;
			}
			else
			{
				$matching_internal = array_rand($available_internals,1);
				$matching_internal = $available_internals[$matching_internal];
			}
		}
		
		$USER->Browsers[0]->DesiredChatPartner = $matching_internal;
		$response .= "lz_chat_add_system_text(6,null);";
	}
	elseif(isset($fromDepartmentBusy) && $fromDepartmentBusy)
	{	
		if(!$USER->Browsers[0]->Waiting)
		{
			$USER->AddFunctionCall("lz_chat_add_system_text(7,null);",false);
			$USER->Browsers[0]->DesiredChatPartner = null;
			$USER->Browsers[0]->Waiting = true;
		}
	}
	else
	{
		$USER->Browsers[0]->Waiting = false;
		$USER->AddFunctionCall("lz_chat_set_status(2);",false);
		$USER->AddFunctionCall("lz_chat_add_system_text(8,null);",false);
		$USER->AddFunctionCall("lz_chat_stop_system();",false);
	}
	return $response;
}

function getSessionId()
{
	global $CONFIG;
	if(getCookieValue("userid") != null)
		$session = getCookieValue("userid");
	else
		setCookieValue("userid",$session = getId(7));
	return $session;
}
?>
