<?php

/****************************************************************************************
* LiveZilla intern.build.inc.php
* 
* Copyright 2001-2008 SPAUN Power GmbH
* All rights reserved.
* LiveZilla is a registered trademark.
* 
* Improper changes in this file may cause critical errors. It is strongly 
* recommended to desist from editing this file.
* 
***************************************************************************************/ 

if(!defined("IN_LIVEZILLA"))
	die();

function buildFiles()
{
	global $INTERNAL,$RESPONSE;
	$RESPONSE->InternalFiles = "";
	$subdirs = getDirectory(PATH_UPLOADS,false);
	foreach($subdirs as $dir)
	{
		if(@is_dir(PATH_UPLOADS.$dir."/"))
		{
			$sess = getInternSessIdByUserId($dir);
			if($sess != null)
			{
				$files = getDirectory(PATH_UPLOADS.$dir."/",false);
				foreach($files as $file)
				{
					if($file != FILE_INDEX)
						$RESPONSE->InternalFiles .= "<v os=\"".base64_encode($sess)."\" oi=\"".base64_encode($dir)."\" n=\"".base64_encode($file)."\" s=\"".base64_encode(filesize(PATH_UPLOADS.$dir."/".$file))."\"/>\r\n";
				}
			}
			else
				deleteDirectory(PATH_UPLOADS.$dir."/");
		}
	}
}

function buildFilters()
{
	global $FILTERS,$GROUPS,$INTERNAL,$RESPONSE;
	$RESPONSE->Filter = "";
	if(!$INTERNAL[CALLER_SYSTEM_ID]->IsExternal($GROUPS))
		return;
	getData(false,false,false,true);
	foreach($FILTERS->Filters as $id => $filter)
	{
		if($filter->Expiredate != -1 && ($filter->Expiredate + $filter->Created) < time())
			$filter->Destroy();
		else
			$RESPONSE->Filter .= $filter->GetXML();
	}
}

function buildRatings()
{
	global $RESPONSE,$INTERNAL,$GROUPS;
	if(($permission = $INTERNAL[CALLER_SYSTEM_ID]->GetPermission(PERMISSION_RATINGS)) == PERMISSION_NONE)
		return;
		
	if(file_exists(FILE_ANS_RATINGS) && $_POST[POST_INTERN_XMLCLIP_RATING_END_TIME] != XML_CLIP_NULL && $_POST[POST_INTERN_XMLCLIP_RATING_END_TIME] >= @filemtime(FILE_ANS_RATINGS))
		return;

	if(!$INTERNAL[CALLER_SYSTEM_ID]->IsExternal($GROUPS))
		return;

	$ratings = getDirectory(PATH_RATINGS,"*.htm");
	$xml="";$count=0;
	sort($ratings);
	$ratingss = array();
	foreach($ratings as $file)
		$ratingss[$file] = substr($file,0,10);
	asort($ratingss);
	foreach($ratingss as $file => $time)
	{
		if(stristr($file,EX_CHAT_RATING))
		{
			$id = substr($file,0,strlen($file)-5);
			if($time > $_POST[POST_INTERN_XMLCLIP_RATING_END_TIME] || $_POST[POST_INTERN_XMLCLIP_RATING_END_TIME] == XML_CLIP_NULL)
			{
				$rating = new Rating($id);
				$rating->Load();
				$xml .= $rating->GetXML($INTERNAL,($rating->InternId == $INTERNAL[CALLER_SYSTEM_ID]->UserId || $permission == PERMISSION_FULL));
				if(++$count >= DATA_ITEM_LOADS)
					break;
			}
			else if($time < time()-DATA_LIFETIME)
				@unlink(PATH_RATINGS . $file);
		}
	}
	$RESPONSE->Ratings = (strlen($xml) > 0) ? $xml : null;
}

function buildMessages()
{
	global $RESPONSE,$INTERNAL,$GROUPS;
	if(($permission = $INTERNAL[CALLER_SYSTEM_ID]->GetPermission(PERMISSION_MESSAGES)) == PERMISSION_NONE)
		return;

	if(file_exists(FILE_ANS_MESSAGES) && $_POST[POST_INTERN_XMLCLIP_MESSAGES_END_TIME] != XML_CLIP_NULL && $_POST[POST_INTERN_XMLCLIP_MESSAGES_END_TIME] >= @filemtime(FILE_ANS_MESSAGES))
		return;

	if(!$INTERNAL[CALLER_SYSTEM_ID]->IsExternal($GROUPS))
		return;

	$messages = getDirectory(PATH_MESSAGES,"*.htm");
	$xml="";$count=0;
	$messagess = array();
	foreach($messages as $file)
		$messagess[$file] = @filemtime(PATH_MESSAGES . $file);
	asort($messagess);
	foreach($messagess as $file => $time)
	{
		if(stristr($file,EX_MAIL))
		{
			$id = substr($file,0,strlen($file)-5);
			if($time > $_POST[POST_INTERN_XMLCLIP_MESSAGES_END_TIME] || $_POST[POST_INTERN_XMLCLIP_MESSAGES_END_TIME] == XML_CLIP_NULL)
			{	
				$last = $time;
				$message = new UserTicket($file);
				$message->Load();
				
				$xml .= $message->GetXML($GROUPS,(in_array($message->Group,$INTERNAL[CALLER_SYSTEM_ID]->Groups) || $permission == PERMISSION_FULL));
				if(++$count >= DATA_ITEM_LOADS)
					break;
			}
			else if($time < time()-DATA_LIFETIME)
				@unlink(PATH_MESSAGES . $file);
		}
	}
	
	if($count == 0)
	{
		$closed = getDirectory(PATH_MESSAGES_CLOSED,"*.htm");
		$closeds = array();
		
		foreach($closed as $file)
			$closeds[$file] = @filemtime(PATH_MESSAGES_CLOSED . $file);
		asort($closeds);
		
		foreach($closeds as $file => $time)
		{
			if(stristr($file,EX_MAIL))
			{
				if($time > $_POST[POST_INTERN_XMLCLIP_MESSAGES_END_TIME] || $_POST[POST_INTERN_XMLCLIP_MESSAGES_END_TIME] == XML_CLIP_NULL)
				{
					$id = str_replace("." . EX_MAIL,"",$file);
					$ticket = new ClosedTicket($id);
					$ticket->Load();
					
					$xml .= $ticket->GetXML($time);
				}
				else if($time < time()-DATA_LIFETIME)
					@unlink(PATH_MESSAGES_CLOSED . $file);
			}
		}
	}
	$RESPONSE->Messages = (strlen($xml) > 0) ? $xml : null;
}

function buildNewPosts()
{
	global $INTERNAL,$CONFIG,$RESPONSE;
	foreach($INTERNAL[CALLER_SYSTEM_ID]->GetPosts() as $systemid => $postarray)
		foreach($postarray as $post)
		{
			$RESPONSE->Posts .= $post->GetXml($systemid);
			LogPost($systemid,$post,false);
		}
}

function buildIntern()
{
	global $CONFIG,$INTERNAL,$GROUPS,$RESPONSE;
	$builder = new InternalXMLBuilder($CONFIG,$INTERNAL[CALLER_SYSTEM_ID],$INTERNAL,$GROUPS);
	$builder->Generate();
	$RESPONSE->Internals = $builder->XMLInternal;
	$RESPONSE->Typing .= $builder->XMLTyping;
	$RESPONSE->InternalProfilePictures = $builder->XMLProfilePictures;
	$RESPONSE->InternalWebcamPictures = $builder->XMLWebcamPictures;
	$RESPONSE->Groups = $builder->XMLGroups;
	$RESPONSE->InternalVcards = $builder->XMLVisitcards;
}

function buildExtern()
{
	global $CONFIG,$VISITOR,$INTERNAL,$GROUPS,$RESPONSE;
	$RESPONSE->Tracking = "";

	if(count($VISITOR) > 0)
	{
		$builder = new ExternalXMLBuilder($CONFIG,$INTERNAL[CALLER_SYSTEM_ID],$VISITOR,(LOGIN || $_POST[POST_INTERN_XMLCLIP_HASH_EXTERN] == XML_CLIP_NULL),($GROUPS[$INTERNAL[CALLER_SYSTEM_ID]->Groups[0]]["gr_extern"] == 1));
		$builder->SessionFileSizes = $INTERNAL[CALLER_SYSTEM_ID]->VisitorFileSizes;
		$builder->StaticReload = $INTERNAL[CALLER_SYSTEM_ID]->VisitorStaticReload;
		$builder->Generate();
		$RESPONSE->Tracking = $builder->XMLCurrent;
		$RESPONSE->Typing .= $builder->XMLTyping;
		$INTERNAL[CALLER_SYSTEM_ID]->VisitorFileSizes = $builder->SessionFileSizes;
		$INTERNAL[CALLER_SYSTEM_ID]->VisitorStaticReload = $builder->StaticReload;
	}
	else
		$INTERNAL[CALLER_SYSTEM_ID]->VisitorFileSizes = array();
}
?>
