<?php
/****************************************************************************************
* LiveZilla functions.intern.inc.php
* 
* Copyright 2001-2008 SPAUN Power GmbH
* All rights reserved.
* LiveZilla is a registered trademark.
* 
* Improper changes in this file may cause critical errors. It is strongly 
* recommended to desist from editing this file.
* 
***************************************************************************************/ 

if(!defined("IN_LIVEZILLA"))
	die();

function validate()
{
	global $INTERNAL,$GROUPS,$RESPONSE,$CONFIG;
	if(isset($_POST[POST_INTERN_AUTHENTICATION_USERID]) && isset($_POST[POST_INTERN_AUTHENTICATION_PASSWORD]))
	{
		foreach($INTERNAL as $sysId => $internuser)
		{
			if(strtolower($internuser->UserId) == strtolower($_POST[POST_INTERN_AUTHENTICATION_USERID]))
			{
				$internuser->SetStaticCaller();
				if(isset($_POST[POST_INTERN_NEW_PASSWORD]))
					$INTERNAL[CALLER_SYSTEM_ID]->ChangePassword($_POST[POST_INTERN_NEW_PASSWORD]);
				if(LOGIN || SERVERSETUP)
				{
					$INTERNAL[CALLER_SYSTEM_ID]->LoadPassword();
					if(isset($_POST[POST_INTERN_VERSION]) && VERSION != $_POST[POST_INTERN_VERSION])
						define("INVALID_CLIENT_VERSION",true);
				}
				
				if(isset($INTERNAL[CALLER_SYSTEM_ID]->Password) && $INTERNAL[CALLER_SYSTEM_ID]->Password == md5($_POST[POST_INTERN_AUTHENTICATION_PASSWORD]))
				{
					if(LOGIN && !SERVERSETUP && $INTERNAL[CALLER_SYSTEM_ID]->LastActive != null && $INTERNAL[CALLER_SYSTEM_ID]->LastActive > (time()-$CONFIG["timeout_clients"]))
					{
						if(isset($INTERNAL[CALLER_SYSTEM_ID]->LoginId) && $_POST[POST_INTERN_AUTHENTICATION_LOGINID] != $INTERNAL[CALLER_SYSTEM_ID]->LoginId)
						{
							define("AUTH_RESULT",LOGIN_REPLY_ALREADY_ONLINE);
							break;
						}
					}
					if(!SERVERSETUP && LOGIN && $INTERNAL[CALLER_SYSTEM_ID]->IsPasswordChangeNeeded())
					{
						define("AUTH_RESULT",LOGIN_REPLY_CHANGE_PASS);
						break;
					}
					
					if(SERVERSETUP && $INTERNAL[CALLER_SYSTEM_ID]->Level != USER_LEVEL_ADMIN)
					{
						define("AUTH_RESULT",LOGIN_REPLY_NOADMIN);
						break;
					}
					
					if(!SERVERSETUP)
						$INTERNAL[CALLER_SYSTEM_ID]->CreateComparer();
					
					define("VALIDATED",true);
					if(!LOGOFF && isset($_POST[POST_INTERN_AUTHENTICATION_LOGINID]))
						$INTERNAL[CALLER_SYSTEM_ID]->LoginId = $_POST[POST_INTERN_AUTHENTICATION_LOGINID];
					elseif(LOGOFF)
						$INTERNAL[CALLER_SYSTEM_ID]->LoginId = null;
					
					define("AUTH_RESULT",LOGIN_REPLY_SUCCEEDED);
					if(!SERVERSETUP)
						$INTERNAL[CALLER_SYSTEM_ID]->Status = ($INTERNAL[CALLER_SYSTEM_ID]->Status == USER_STATUS_OFFLINE) ? USER_STATUS_ONLINE : $INTERNAL[CALLER_SYSTEM_ID]->Status;
					
					if(isset($_POST[POST_GLOBAL_TYPING]) && $_POST[POST_INTERN_SERVER_ACTION] == INTERN_ACTION_LISTEN)
						$INTERNAL[CALLER_SYSTEM_ID]->Typing = $_POST[POST_GLOBAL_TYPING];
					break;
				}
				else
				{
					if($INTERNAL[CALLER_SYSTEM_ID]->LastActive < (time()-$CONFIG["timeout_clients"]))
						$INTERNAL[CALLER_SYSTEM_ID]->Destroy();
					break;
				}
			}
			$INTERNAL[$sysId] = $internuser;
		}
	}
	if(defined("VALIDATED") && LOGIN)
	{
		$INTERNAL[CALLER_SYSTEM_ID]->IP = $_SERVER["REMOTE_ADDR"];
		$INTERNAL[CALLER_SYSTEM_ID]->FirstActive = time();
		$INTERNAL[CALLER_SYSTEM_ID]->VisitorFileSizes = Array();
		$INTERNAL[CALLER_SYSTEM_ID]->VisitorStaticReload = Array();
		$RESPONSE->Login = $INTERNAL[CALLER_SYSTEM_ID]->GetLoginReply($GROUPS[$INTERNAL[CALLER_SYSTEM_ID]->Groups[0]]["gr_extern"],time() - $_POST[POST_INTERN_CLIENT_TIME]);
	}
	if(!defined("AUTH_RESULT"))
	{
		if($INTERNAL[CALLER_SYSTEM_ID]->FileError != null)
			define("AUTH_RESULT",LOGIN_REPLY_IDLE);
		else
			define("AUTH_RESULT",LOGIN_REPLY_BAD_COMBINATION);
	}
}

function receiveFile($id = FILE_ACTION_NONE)
{
	global $RESPONSE;
	if(isset($_POST[POST_INTERN_FILE_TYPE]) && $_POST[POST_INTERN_FILE_TYPE] == FILE_TYPE_USERFILE)
	{
		if(!@is_dir(PATH_UPLOADS.$_POST[POST_INTERN_AUTHENTICATION_USERID]."/"))
		{
			if(!mkdir(PATH_UPLOADS.($_POST[POST_INTERN_AUTHENTICATION_USERID])))
				$id = FILE_ACTION_ERROR;
			else
				createFile(PATH_UPLOADS.($_POST[POST_INTERN_AUTHENTICATION_USERID])."/".FILE_INDEX,"",true);
		}
		if(move_uploaded_file($_FILES["file"]["tmp_name"], (PATH_UPLOADS.$_POST[POST_INTERN_AUTHENTICATION_USERID])."/".$_FILES["file"]["name"]))
			$id = FILE_ACTION_SUCCEEDED;
		else
			$id = FILE_ACTION_ERROR;
	}
	$RESPONSE->SetStandardResponse($id,"");
}

function removeFile($id = FILE_ACTION_NONE)
{
	global $RESPONSE;
	if(SERVERSETUP && isset($_POST[POST_INTERN_FILE_TYPE]) && $_POST[POST_INTERN_FILE_TYPE] == FILE_TYPE_ADMIN_BANNER)
	{
		$files = explode(";",$_POST[POST_INTERN_UPLOAD_VALUE]);
		foreach($files as $file)
			if(file_exists(PATH_BANNER . base64_decode($file)))
				if(unlink(PATH_BANNER . base64_decode($file)))
					$id = FILE_ACTION_SUCCEEDED;
				else
					$id = FILE_ACTION_ERROR;
	}
	else if(isset($_POST[POST_INTERN_FILE_TYPE]) && $_POST[POST_INTERN_FILE_TYPE] == FILE_TYPE_CARRIERLOGO)
	{
		if(file_exists(FILE_CARRIERLOGO))
		{
			if(unlink(FILE_CARRIERLOGO))
				$id = FILE_ACTION_SUCCEEDED;
			else
				$id = FILE_ACTION_ERROR;
		}
	}
	$RESPONSE->SetStandardResponse($id,"");
}

function processActions()
{
	require("./_lib/functions.internal.process.inc.php");
	processAcceptedConversations();
	processAuthentications();
	processStatus();
	processDeleteFiles();
	processClosures();
	processRequests();
	processForwards();
	processGuides();
	processFilters();
	processVisitcards();
	processProfilePictures();
	processWebcamPictures();
	processAlerts();
	processPermissions();
	processClosedTickets();
	processExternalReloads();
	if(SERVERSETUP)
		processBannerPictures();
}

function buildSystem()
{
	global $RESPONSE;
	require_once("./_lib/functions.internal.build.inc.php");
	removeChats();
	buildIntern();
	buildExtern();
	buildNewPosts();
	buildFiles();
	buildFilters();
	if(!LOGIN && !SERVERSETUP)
	{
		buildRatings();
		buildMessages();
	}
}

function listenXML($runs = 1)
{
	global $CONFIG,$RESPONSE,$INTERNAL;
	processActions();
	
	if(!SERVERSETUP && $INTERNAL[CALLER_SYSTEM_ID]->Status == USER_STATUS_OFFLINE)
		return;
		
	$start = time();
	while(time() < $start + getLongPollRuntime() || $runs == 1)
	{
		if($runs > 1)
		{
			getData(true,true,true,true);
			$INTERNAL[CALLER_SYSTEM_ID]->CreateComparer();
		}
			
		$RESPONSE->XML = "<listen disabled=\"".base64_encode(((getAvailability()) ?  "0" : "1" ))."\" h=\"<!--gl_all-->\" ".((isset($_POST[POST_INTERN_XMLCLIP_HASH_EXECUTION_TIME])) ? "ex_time=\"<!--execution_time-->\"" : "").">\r\n";
		$RESPONSE->Typing = "";
		if($RESPONSE->Login != null)
			$RESPONSE->XML .= $RESPONSE->Login;
			
		buildSystem();
		
		if($runs++ == 1)
			processPosts();
		
		if(($hash = substr(md5($RESPONSE->Typing),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_TYPING] && strlen($RESPONSE->Typing) > 0)
			$RESPONSE->XML .= "<gl_typ h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->Typing . "</gl_typ>\r\n";
		if(($hash = substr(md5($RESPONSE->Exceptions),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_ERRORS] && strlen($RESPONSE->Exceptions) > 0)
			$RESPONSE->XML .= "<gl_e h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->Exceptions . "</gl_e>\r\n";
		if(($hash = substr(md5($RESPONSE->Internals),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_INTERN] && strlen($RESPONSE->Internals) > 0)
			$RESPONSE->XML .= "<int_r h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->Internals . "</int_r>\r\n";
		if(($hash = substr(md5($RESPONSE->Groups),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_GROUPS] && strlen($RESPONSE->Groups) > 0)
			$RESPONSE->XML .= "<int_d h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->Groups . "</int_d>\r\n";
		if(($hash = substr(md5($RESPONSE->InternalFiles),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_FILES])
			$RESPONSE->XML .= "<int_f h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->InternalFiles . "</int_f>\r\n";
		if(($hash = substr(md5($RESPONSE->InternalVcards),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_VISITCARDS])
			$RESPONSE->XML .= "<int_v h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->InternalVcards . "</int_v>\r\n";
		if(($hash = substr(md5($RESPONSE->InternalProfilePictures),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_PICTURES_PROFILE])
			$RESPONSE->XML .= "<int_pp h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->InternalProfilePictures . "</int_pp>\r\n";
		if(($hash = substr(md5($RESPONSE->InternalWebcamPictures),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_PICTURES_WEBCAM])
			$RESPONSE->XML .= "<int_wp h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->InternalWebcamPictures . "</int_wp>\r\n";
		if(($hash = substr(md5($RESPONSE->Filter),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_FILTERED])
			$RESPONSE->XML .= "<ext_b h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->Filter . "</ext_b>\r\n";
		if(($hash = substr(md5($RESPONSE->Tracking),0,5)) != @$_POST[POST_INTERN_XMLCLIP_HASH_EXTERN])
			$RESPONSE->XML .= "<ext_u h=\"".base64_encode($hash)."\">\r\n" . $RESPONSE->Tracking . "</ext_u>\r\n";
		if($RESPONSE->Ratings != null)
			$RESPONSE->XML .= "<ext_r>\r\n" . $RESPONSE->Ratings . "</ext_r>\r\n";
		if($RESPONSE->Messages != null)
			$RESPONSE->XML .= "<ext_m>\r\n" . $RESPONSE->Messages . "</ext_m>\r\n";
		if(strlen($RESPONSE->Authentications) > 0)
			$RESPONSE->XML .= "<gl_auths>\r\n" . $RESPONSE->Authentications . "\r\n</gl_auths>\r\n";
		if(strlen($RESPONSE->Posts)>0)
			$RESPONSE->XML .=  "<usr_p>\r\n" . $RESPONSE->Posts . "</usr_p>\r\n";
		if(isset($_POST[POST_INTERN_ACCESSTEST]))
			$RESPONSE->XML .= "<permission>" . base64_encode(getFolderPermissions()) . "</permission>";
	
		if(SERVERSETUP || LOGIN || $INTERNAL[CALLER_SYSTEM_ID]->LastActive <= @filemtime(FILE_CONFIG))
			$RESPONSE->XML .= getConfig();
			
		$RESPONSE->XML .= "</listen>";
		
		if(substr_count($RESPONSE->XML,"<") > 4 || $INTERNAL[CALLER_SYSTEM_ID]->Status == USER_STATUS_OFFLINE || isset($_POST[POST_GLOBAL_LAST_CONNECTION_FAILED]))
		{
			break;
		}
		else
		{
			if(isset($_POST[POST_GLOBAL_SHOUT]))
				break;

			$wait = max($CONFIG["poll_frequency_clients"]-1,1);
			if(time()+$wait <= $start + getLongPollRuntime())
				sleep($wait);
			else
				break;
		}
	}
}

function getConfig()
{
	global $CONFIG;
	$xml = "<gl_c h=\"".base64_encode(substr(md5file(FILE_CONFIG),0,5))."\">\r\n";
	foreach($CONFIG as $key => $val)
	{
		if(is_array($val))$val = implode(";",$val);
		$xml .= "<conf value=\"".base64_encode($val)."\" />\r\n";
	}
	if(SERVERSETUP && file_exists(FILE_CARRIERLOGO))
		$xml .= "<carrier_logo content=\"".fileToBase64(FILE_CARRIERLOGO)."\" />\r\n";
	$xml .= "<php_cfg_vars post_max_size=\"".base64_encode(cfgFileSizeToBytes((@get_cfg_var("post_max_size")!=NULL)?get_cfg_var("post_max_size"):MAX_POST_SIZE_SAFE_MODE))."\" upload_max_filesize=\"".base64_encode(cfgFileSizeToBytes((@get_cfg_var("upload_max_filesize")!=NULL)?get_cfg_var("upload_max_filesize"):MAX_UPLOAD_SIZE_SAFE_MODE))."\" />\r\n";
	$xml .= "</gl_c>\r\n";
	return $xml;
}

function removeChats()
{
	global $INTERNAL,$CONFIG,$GROUPS,$FILTERS,$RESPONSE;
	$INTERNAL[CALLER_SYSTEM_ID]->GetExternalObjects();
	foreach($INTERNAL[CALLER_SYSTEM_ID]->ExternalChats as $chat)
	{
		if($chat->MemberCount > 1 && file_exists($chat->TargetFileExternal))
		{
			if(@filemtime($chat->ExternalUser->SessionFile) < (time()-$CONFIG["timeout_clients"]))
				$chat->ExternalUser->Destroy($CONFIG);
		}
		else
			$chat->InternalDestroy();
	}
}

function getFolderPermissions($message=null)
{
	$directories = Array(PATH_DATA,PATH_UPLOADS,PATH_INTERN_IMAGES,PATH_BANNER,PATH_VISITCARDS,PATH_CONFIG,PATH_USERS,PATH_GROUPS,PATH_MESSAGES,PATH_RATINGS);
	foreach($directories as $key => $dir)
	{
		$result = testDirectory($dir);
			if(!$result)
				return 0;
	}
	return 1;
}

function LogPost($_systemId,$_post,$_out)
{
	global $CONFIG,$INTERNAL,$VISITOR,$GROUPS;
	if($_systemId == GROUP_EVERYONE_INTERN)
	{
		$logtype = 1;
		if(substr($CONFIG["gl_log"],2,1))$_file = PATH_CHAT_LOGS . date("m_d_y") . "_" . GROUP_EVERYONE_INTERN . ".log";
		else return;
	}
	else if($_systemId == GROUP_EVERYONE_EXTERN)
	{
		$logtype = 2;
		if(substr($CONFIG["gl_log"],2,1))$_file = PATH_CHAT_LOGS . date("m_d_y") . "_" . GROUP_EVERYONE_EXTERN . ".log";
		else return;
	}
	else if(isset($GROUPS[$_systemId]))
	{
		$logtype = 3;
		if(substr($CONFIG["gl_log"],2,1))$_file = PATH_CHAT_LOGS . date("m_d_y") . "_" . strtolower($_systemId) . ".log";
		else return;
	}
	else if(is_array($INTERNAL) && isset($INTERNAL[$_systemId]))
	{
		$logtype = 4;
		if($_out && substr($CONFIG["gl_log"],1,1))
		{
			$sorter = Array($_systemId,CALLER_SYSTEM_ID);
			sort($sorter);
			$_file = PATH_CHAT_LOGS . date("m_d_y") . "_" . CALLER_TYPE_INTERNAL . "_" . $sorter[0] . "_" . $sorter[1] . ".log";
		}
		else return;
	}
	else if(substr($CONFIG["gl_log"],0,1))
	{
		$logtype = 5;
	 	$_file = PATH_CHAT_LOGS . date("m_d_y") . "_" . CALLER_TYPE_EXTERNAL . "_" . CALLER_SYSTEM_ID . "_" . $_systemId . ".log";
	}
	else
		return;
	
	if(!@is_dir(PATH_CHAT_LOGS))
		@mkdir(PATH_CHAT_LOGS);
		
	if(!file_exists(PATH_CHAT_LOGS . FILE_INDEX))
		if(!@copy("./_log/" . FILE_INDEX,PATH_CHAT_LOGS . FILE_INDEX))
			createFile(PATH_CHAT_LOGS . FILE_INDEX,"",false);
	
	$parts = explode("~",$_systemId);
	if($_out)
	{
		$sender = $INTERNAL[CALLER_SYSTEM_ID]->Fullname;
		$_post->Text = strip_tags($_post->Text);
	}
	else
		$sender = $VISITOR[$parts[0]]->Browsers[$parts[1]]->Fullname;

	if(!file_exists($_file))
	{
		if($logtype != 5)
			logit("Live Support Chat Transcript [powered by LiveZilla.net]\r\nDate: " . date("r")."\r\n-------------------------------------------------------",$_file);
		else
		{
			$user = $VISITOR[$parts[0]]->Browsers[$parts[1]];
			if($_out)
				$user->Load();
			logit("Live Support Chat Transcript [powered by LiveZilla.net]\r\nDate: " . date("r")."\r\n-------------------------------------------------------\r\nName: " . $user->Fullname . "\r\nEmail: " . $user->Email . "\r\nCompany: " . $user->Company ."\r\n-------------------------------------------------------",$_file);
		}
	}

	$special = strlen($_post->Special) > 0 ? " (" . $_post->Special . ")" : "";
	logit("|" . date("m.d.y H:i:s") . "| " . $sender .  ": " . $_post->Text . $special,$_file);
	
	if(rand(1,20) == 1)
	{
		$chats = getDirectory(PATH_CHAT_LOGS,FILE_INDEX);
		foreach($chats as $chat)
			if(@filemtime(PATH_CHAT_LOGS . $chat) < time()-DATA_LIFETIME)
				@unlink(PATH_CHAT_LOGS . $chat);
	}
}
?>
