<?php

/****************************************************************************************
* LiveZilla functions.internal.process.inc.php
* 
* Improper changes in this file may cause critical errors. It is strongly 
* recommended to desist from editing this file.
* 
***************************************************************************************/ 

if(!defined("IN_LIVEZILLA"))
	die();

function processAcceptedConversations()
{
	if(isset($_POST[POST_INTERN_PROCESS_ACCEPTED_USERS]))
		appendAcceptedConversations();
}

function processAuthentications()
{
	if(isset($_POST[POST_INTERN_PROCESS_AUTHENTICATIONS_USERS]))
		appendAuthentications();
}

function processStatus()
{
	if(isset($_POST[POST_INTERN_USER_STATUS]))
		appendStatus();
}

function processAlerts()
{
	if(isset($_POST[POST_INTERN_PROCESS_ALERTS]))
		appendAlerts();
}

function processClosures()
{
	if(isset($_POST[POST_INTERN_PROCESS_CLOSURES_USERS]))
		appendClosures();
}

function processPosts()
{
	if(isset($_POST[POST_INTERN_PROCESS_POSTS_HTML]))
		appendPosts();
}

function processForwards()
{
	if(isset($_POST[POST_INTERN_PROCESS_FORWARDS_USERS]))
		appendForwards();
}

function processRequests()
{
	if(isset($_POST[POST_INTERN_PROCESS_REQUESTS_VISITORS]))
		appendRequests();
}

function processGuides()
{
	if(isset($_POST[POST_INTERN_PROCESS_GUIDES_VISITORS]))
		appendGuides();
}

function processFilters()
{
	if(isset($_POST[POST_INTERN_PROCESS_FILTERS_FILTERIDS]))
		appendFilters();
}

function processDeleteFiles()
{
	if(isset($_POST[POST_INTERN_PROCESS_DELETE_FILES]))
		appendDeleteFiles();
}

function processVisitcards()
{
	if(isset($_POST[POST_INTERN_PROCESS_VISITCARDS]))
		appendVisitcards();
}

function processProfilePictures()
{
	if(isset($_POST[POST_INTERN_PROCESS_PICTURES]))
		appendProfilePictures();
}

function processWebcamPictures()
{
	if(isset($_POST[POST_INTERN_PROCESS_PICTURES_WEBCAM]))
		appendWebcamPictures();
}

function processBannerPictures()
{
	if(isset($_POST[POST_INTERN_PROCESS_BANNER_ONLINE_NAME]))
		appendBannerPictures();
}

function processPermissions()
{
	if(isset($_POST[POST_INTERN_PROCESS_PERMISSIONS_IDS]))
		appendPermissions();
}

function processExternalReloads()
{
	if(isset($_POST[POST_INTERN_PROCESS_EXTERNAL_RELOADS]))
		appendExternalReloads();
}

function processClosedTickets()
{
	if(isset($_POST[POST_INTERN_PROCESS_ACCEPTED_MESSAGE_IDS]))
		appendClosedTickets();
}

function appendClosedTickets()
{
	global $INTERNAL;
	$msgids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_ACCEPTED_MESSAGE_IDS]);
	$msgnames = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_ACCEPTED_MESSAGE_NAMES]);
	foreach($msgids as $key => $id)
	{
		$ticket = new ClosedTicket($id);
		if(!@file_exists($ticket->TargetFile))
		{
			$ticket->Sender = $msgnames[$key];
			$ticket->Save();
			$ticket->Announce();
		}
	}
}

function appendExternalReloads()
{
	global $INTERNAL;
	$INTERNAL[CALLER_SYSTEM_ID]->ExternalReloads = Array();
	$userids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_EXTERNAL_RELOADS]);
	foreach($userids as $id)
		$INTERNAL[CALLER_SYSTEM_ID]->VisitorStaticReload[$id] = true;
}

function appendPermissions()
{
	$systemids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_PERMISSIONS_SYSTEMIDS]);
	$ids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_PERMISSIONS_IDS]);
	$results = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_PERMISSIONS_RESULTS]);
	$types = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_PERMISSIONS_TYPES]);

	foreach($ids as $key => $id)
	{
		$user_parts = explode("~",$systemids[$key]);
		$permission = new Permission($types[$key],$user_parts[0],$user_parts[1],$ids[$key]);
		$permission->Result = $results[$key];
		$permission->Save();
	}
}

function appendForwards()
{
	global $INTERNAL;
	$users = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_FORWARDS_USERS]));
	$receivers = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FORWARDS_RECEIVERS]);
	$additions = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_FORWARDS_ADDITIONS]));
	$conversations = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_FORWARDS_CONVERSATIONS]));

	foreach($users as $key => $user)
	{
		$parts = explode("~",$user);
		$forward = new Forward($parts[0],$parts[1],$INTERNAL[CALLER_SYSTEM_ID]->SystemId);
		$forward->TargetSessId = $receivers[$key];
		$forward->TargetGroupId = $INTERNAL[$receivers[$key]]->Groups[0];
		if(strlen($additions[$key]) > 0)
			$forward->Text = $additions[$key];
		if(strlen($conversations[$key]) > 0)
			$forward->Conversation = $conversations[$key];
		$forward->Save();
	}
}

function appendAuthentications()
{
	global $INTERNAL,$RESPONSE;
	$users = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_AUTHENTICATIONS_USERS]);
	$passwords = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_AUTHENTICATIONS_PASSWORDS]);
	foreach($users as $key => $user)
	{
		$INTERNAL[$user]->ChangePassword($passwords[$key]);
		$RESPONSE->Authentications = "<val userid=\"".base64_encode($user)."\" pass=\"".base64_encode($passwords[$key])."\" />\r\n";
	}
}

function appendGuides()
{
	global $INTERNAL,$VISITOR;
	$guides = Array();
	$visitors = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_GUIDES_VISITORS]);
	$asks = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_GUIDES_ASKINGS]);
	$urls = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_GUIDES_URLS]));
	$browids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_GUIDES_BROWSERIDS]);
	$texts = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_GUIDES_TEXTS]));
	foreach($visitors as $key => $visitor)
	{
		if(isset($VISITOR[$visitors[$key]]))
		{
			$guide = new Guide($INTERNAL[CALLER_SYSTEM_ID]->SessId,$visitors[$key],$browids[$key],$asks[$key]);
			$guide->SenderFullname = $INTERNAL[CALLER_SYSTEM_ID]->Fullname;
			$guide->Text = $texts[$key];
			$guide->TargetURL = $urls[$key];
			$guides[$visitors[$key].$browids[$key]] = $guide;
		}
	}
	foreach($guides as $guide)
		$guide->Save();
}

function appendAlerts()
{
	global $VISITOR;
	$alerts = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_ALERTS]));
	$visitors = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_ALERT_RECEIVERS]);
	$browsers = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_ALERT_BROWSERS]);
	foreach($alerts as $key => $text)
	{
		if(isset($visitors[$key]) && isset($VISITOR[$visitors[$key]]))
		{
			$alert = new Alert(bigTime(),$visitors[$key],$browsers[$key]);
			$alert->Alert = $alerts[$key];
			$alert->Save();
		}
	}
}

function appendRequests()
{
	global $INTERNAL,$VISITOR;
	$visitors = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_REQUESTS_VISITORS]);
	$browids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_REQUESTS_BROWSERIDS]);
	$reqnames = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_REQUESTS_NAMES]));
	$reqids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_REQUESTS_IDS]);
	$reqtexts = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_REQUESTS_TEXTS]));
	foreach($reqids as $key => $requestid)
		if(isset($VISITOR[$visitors[$key]]))
		{
			$request = new ChatRequest($INTERNAL[CALLER_SYSTEM_ID]->SessId,$visitors[$key],$browids[$key],REQUEST_STATUS_ACTIVE);
			$request->SenderUserId = $INTERNAL[CALLER_SYSTEM_ID]->UserId;
			$request->SenderFullname = ($INTERNAL[CALLER_SYSTEM_ID]->Fullname != null) ? $INTERNAL[CALLER_SYSTEM_ID]->Fullname : $INTERNAL[CALLER_SYSTEM_ID]->UserId;
			$request->Text = $reqtexts[$key];
			$request->Save();
		}
}

function appendFilters()
{
	$creators = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_CREATORS]);
	$createds = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_CREATEDS]);
	$editors = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_FILTERS_EDITORS]));
	$ips = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_IPS]);
	$expiredates = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_EXPIREDATES]);
	$userids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_USERIDS]);
	$reasons = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_REASONS]);
	$filternames = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_FILTERNAMES]);
	$filterids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_FILTERIDS]);
	$activestates = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_ACTIVESTATES]);
	$actiontypes = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_ACTIONTYPES]);
	$exertions = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_EXERTIONS]);
	$languages = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_LANGUAGES]);
	$activeipaddresses = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_ACTIVEIPADDRESSES]);
	$activeuserids = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_ACTIVEUSERIDS]);
	$activelanguages = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_FILTERS_ACTIVELANGUAGES]);
	foreach($filterids as $key => $id)
	{
		$filter = new Filter($filterids[$key]);
		$filter->Creator = $creators[$key];
		$filter->Created = ($createds[$key] != "0") ? $createds[$key] : time();
		$filter->Editor = $editors[$key];
		$filter->Edited = time();
		$filter->IP = $ips[$key];
		$filter->Expiredate = $expiredates[$key];
		$filter->Userid = $userids[$key];
		$filter->Reason = $reasons[$key];
		$filter->Filtername = $filternames[$key];
		$filter->Activestate = $activestates[$key];
		$filter->Exertion = $exertions[$key];
		$filter->Languages = $languages[$key];
		$filter->Activeipaddress = $activeipaddresses[$key];
		$filter->Activeuserid = $activeuserids[$key];
		$filter->Activelanguage = $activelanguages[$key];
		
		if($actiontypes[$key] == POST_ACTION_ADD || $actiontypes[$key] == POST_ACTION_EDIT)
			$filter->Save();
		else if($actiontypes[$key] == POST_ACTION_REMOVE)
			$filter->Destroy();
	}
}

function appendClosures()
{
	global $INTERNAL;
	$users = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_CLOSURES_USERS]));
	$browsers = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_CLOSURES_BROWSERS]));
	$types = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_CLOSURES_TYPES]));
	foreach($users as $key => $userid)
	{
		$chat = new Chat(new ExternalChat($userid,$browsers[$key]),$INTERNAL[CALLER_SYSTEM_ID]);
		if($types[$key] == CHAT_CLOSED)
			$chat->InternalClose();
		else if($types[$key] == CHAT_DECLINED)
			$chat->InternalDecline();
	}
}

function appendPosts()
{
	global $INTERNAL,$GROUPS,$VISITOR;
	$posts = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_POSTS_HTML]));
	$receivers = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_POSTS_RECEIVER]));
	$specials = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_POSTS_SPECIAL]));
	$titles = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_POSTS_TITLE]));
	$postids = explode(POST_ACTION_VALUE_SPLITTER,stripslashes($_POST[POST_INTERN_PROCESS_POSTS_ID]));
	
	$PostMan = new PostMan($INTERNAL[CALLER_SYSTEM_ID],$INTERNAL,$GROUPS);
	foreach($posts as $key => $post)
	{
		if($PostMan->AddPost(new Post($postids[$key],$INTERNAL[CALLER_SYSTEM_ID],$receivers[$key],$posts[$key],$titles[$key],$specials[$key],time())))
			LogPost($receivers[$key],new Post($postids[$key],$INTERNAL[CALLER_SYSTEM_ID],$receivers[$key],$posts[$key],$titles[$key],$specials[$key],time()),true);
	}
	$PostMan->Save();
}

function appendStatus()
{
	global $INTERNAL,$CONFIG;
	$INTERNAL[CALLER_SYSTEM_ID]->Status = $_POST[POST_INTERN_USER_STATUS];
}

function appendDeleteFiles()
{
	$filesToDelete = explode(POST_ACTION_VALUE_SPLITTER,($_POST[POST_INTERN_PROCESS_DELETE_FILES]));
	$fileOwners = explode(POST_ACTION_VALUE_SPLITTER,($_POST[POST_INTERN_PROCESS_DELETE_OWNERS]));
	$fileTypes = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_DELETE_TYPES]));
	foreach($filesToDelete as $key => $item)
		if(strlen($item) > 0)
		{
			if($fileTypes[$key] == FILE_TYPE_FOLDER)
				deleteDirectory(PATH_UPLOADS.$item);
			else
				if(file_exists(PATH_UPLOADS.$fileOwners[$key]."/".$item))
					unlink(PATH_UPLOADS.$fileOwners[$key]."/".$item);
		}
}

function appendProfilePictures()
{
	global $INTERNAL;
	$pictures = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_PICTURES]));
	foreach($pictures as $key => $item)
	{
		$filename = PATH_INTERN_IMAGES . "/" . base64_encode($INTERNAL[CALLER_SYSTEM_ID]->UserId) . FILE_EXTENSION_PROFILE_PICTURE;
		if(file_exists($filename))
			unlink($filename);
		if(strlen($item) > 0)
			base64ToFile($filename,$item);
	}
}

function appendRatings()
{
	$ratings = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_DELETE_RATING]));
	foreach($ratings as $key => $rating)
		@unlink(PATH_RATINGS . $rating . "." . EX_CHAT_RATING);
}

function appendWebcamPictures()
{
	global $INTERNAL;
	$pictures = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_PICTURES_WEBCAM]));
	foreach($pictures as $key => $item)
	{
		$filename = PATH_INTERN_IMAGES . "/" . base64_encode($INTERNAL[CALLER_SYSTEM_ID]->UserId) . FILE_EXTENSION_WEBCAM_PICTURE;
		if(file_exists($filename))
			unlink($filename);
		if(strlen($item) > 0)
			base64ToFile($filename,$item);
	}
}

function appendBannerPictures()
{
	if(file_exists(PATH_BANNER.$_POST[POST_INTERN_PROCESS_BANNER_ONLINE_NAME]))
		unlink(PATH_BANNER.$_POST[POST_INTERN_PROCESS_BANNER_ONLINE_NAME]);
	base64ToFile(PATH_BANNER.$_POST[POST_INTERN_PROCESS_BANNER_ONLINE_NAME],$_POST[POST_INTERN_PROCESS_BANNER_ONLINE_FILE]);
	
	if(file_exists(PATH_BANNER.$_POST[POST_INTERN_PROCESS_BANNER_OFFLINE_NAME]))
		unlink(PATH_BANNER.$_POST[POST_INTERN_PROCESS_BANNER_OFFLINE_NAME]);
	base64ToFile(PATH_BANNER.$_POST[POST_INTERN_PROCESS_BANNER_OFFLINE_NAME],$_POST[POST_INTERN_PROCESS_BANNER_OFFLINE_FILE]);
}

function appendVisitcards()
{
	global $INTERNAL;
	$visitcards = explode(POST_ACTION_VALUE_SPLITTER,$_POST[POST_INTERN_PROCESS_VISITCARDS]);
	foreach($visitcards as $key => $item)
	{
		$filename = PATH_VISITCARDS . "/" . $INTERNAL[CALLER_SYSTEM_ID]->UserId . FILE_EXTENSION_VISITCARD;
		if(strlen($item) > 0)
			createFile($filename,base64_decode($item),true);
		else
			@unlink($filename);
	}
}

function appendAcceptedConversations()
{
	global $INTERNAL;
	$users = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_ACCEPTED_USERS]));
	$browsers = explode(POST_ACTION_VALUE_SPLITTER,utf8_decode($_POST[POST_INTERN_PROCESS_ACCEPTED_BROWSERS]));
	foreach($users as $key => $userid)
	{
		if(strlen($browsers[$key]) > 0 && strlen($userid) > 0)
		{
			$chat = new Chat(new ExternalChat($userid,$browsers[$key]),$INTERNAL[CALLER_SYSTEM_ID]);
			$chat->InternalActivate();
		}
	}
}
?>